package org.aiwolf.pronto;

import java.util.ArrayList;

import org.aiwolf.client.lib.ComingoutContentBuilder;
import org.aiwolf.client.lib.Content;
import org.aiwolf.client.lib.EstimateContentBuilder;
import org.aiwolf.client.lib.RequestContentBuilder;
import org.aiwolf.client.lib.VoteContentBuilder;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.data.Talk;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;



/** 村人役エージェントクラス */
public class ProntoVillager extends ProntoBasePlayer {

	boolean f = true;
	Parameters params;
	boolean update_sh = true;
    boolean doFO = false;
    double ContentRand;

	public void initialize(GameInfo gameInfo, GameSetting gameSetting) {
		super.initialize(gameInfo, gameSetting);
		if (f) {
			params = new Parameters(numAgents);
			sh = new StateHolder(numAgents);
			f = false;
		}
		ArrayList<Integer> fixed = new ArrayList<Integer>();
		fixed.add(meint);
		sh.process(params, gamedata);

		gamedata.clear();
		sh.head = 0;

		sh.game_init(fixed, meint, numAgents, Util.VILLAGER, params);
		update_sh = true;
		before = -1;

	}

	protected Agent chooseVote() {
		gamedata.add(new GameData(DataType.VOTESTART, day, meint, meint, meint, false));

		sh.process(params, gamedata);

		int c = 0;

		int c2 = -1;
		double mn = -1e9; //-10^9
		//if(sh.gamestate.cnt_vote(meint) * 2 >= currentGameInfo.getAliveAgentList().size()){

		if (numAgents == 5) {
			c = chooseMostLikelyWerewolf();
		} else {
			if (day==0) { //初日は占い師CO以外でMostLikelyWerewolf
				for (int j = 0; j < numAgents; j++)
					if (j != meint && agents[j].COrole != Role.SEER) //自分かつ占い師COじゃないなら
						if (sh.gamestate.agents[j].Alive) { //生きているなら
							double score = sh.rp.getProb(j, Util.WEREWOLF) + sh.gamestate.cnt_vote(j) * 0.0001; 
							//(stateholder -> roleprediction で推定した人狼の可能性) + (そのプレイヤーに投票宣言している人の数 × 0.0001)
							if (mn < score) { //最大値を取ってくる
								mn = score;
								c2 = j;
							}
						}
				c=c2;
			}
			else {
				c = chooseMostLikelyExecuted(getAliveAgentsCount() * 0.5);
				if (c == -1) {
					c = chooseMostLikelyWerewolf();
				}
			}
			
		}
		if (!isValidIdx(c)) {
			return null;
		}
		return currentGameInfo.getAgentList().get(c);
	}

	
	protected String chooseTalk() {
		if (lastTurn == -1 || (lastTalkTurn == lastTurn)) {
			gamedata.add(new GameData(DataType.TURNSTART, day, meint, meint, meint, false));
			lastTurn++;
		}

		sh.process(params, gamedata);
		System.out.println("GAMETURN = " + lastTurn + " " + sh.gamestate.turn);

		lastTalkTurn = lastTurn;

		updateState(sh);
		if (update_sh) {
			update_sh = false;
			sh.serach(1000);
		}

		double mn = -1;
		int c = 0;

		if (numAgents == 5) {
			if (day == 1 && sh.gamestate.turn == 1) {
				return Talk.SKIP;
			}
		} else {
			if (day == 1 && sh.gamestate.turn == 1) {
				//return Talk.SKIP;
			}
		}
		if (numAgents == 5) {
			c = chooseMostLikelyWerewolf();
		} else {
			c = chooseMostLikelyExecuted(getAliveAgentsCount() * 0.7);
			if (c == -1) {
				c = chooseMostLikelyWerewolf();
			}
		}
		System.out.println("willvote " + (c + 1) + " " + mn);

		if (sh.gamestate.cnt_vote(meint) * 2 >= currentGameInfo.getAliveAgentList().size()) {
			before = -1;
		}
		if (numAgents == 5) {
			if (sh.gamestate.cnt_vote(c) * 2 < currentGameInfo.getAliveAgentList().size()) {
				before = -1;
			}
		}
		if (before != c) {
			if (!isValidIdx(c)) {return Talk.SKIP;}
			voteCandidate = currentGameInfo.getAgentList().get(c);
			// この下の行をコメントアウトするとずっとしゃべり続ける多弁になる
			// before = c;
			 {
					ContentRand = rnd.nextDouble();
					// 30%
					if(ContentRand <= 0.3) {return (new Content(new VoteContentBuilder(voteCandidate))).getText();}
					// 40%
					else if( ContentRand > 0.3 && ContentRand <= 0.7){return (new Content(new EstimateContentBuilder(voteCandidate, Role.WEREWOLF))).getText();}
					// 30% REQUEST ANY (VOTE [agent])
					else {return (new Content(new RequestContentBuilder(Content.ANY, new Content(new VoteContentBuilder(voteCandidate))))).getText();}
			 }
		}
		
		// フルオープンの処理
		if(!doFO) {
			doFO = true;
			return (new Content(new RequestContentBuilder(Content.ANY, new Content(new ComingoutContentBuilder(Content.ANY,Role.ANY))))).getText();
		}
		return Talk.SKIP;
	}

	public String whisper() {
		throw new UnsupportedOperationException();
	}

	public Agent attack() {
		throw new UnsupportedOperationException();
	}

	public Agent divine() {
		throw new UnsupportedOperationException();
	}

	public Agent guard() {
		throw new UnsupportedOperationException();
	}

}
